diff --git a/ChangeLog b/ChangeLog
index 9d80804..3a795ec 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,5 +1,9 @@
 2017-08-11  Siddhesh Poyarekar  <siddhesh@sourceware.org>
 
+	* benchtests/bench-memmove-large.c: Print output in JSON
+	format.
+	* benchtests/bench-memmove.c: Likewise.
+
 	* benchtests/bench-memccpy.c (do_one_test): Remove checks.
 	* benchtests/bench-memchr.c (do_one_test): Likewise.
 	* benchtests/bench-memcpy-large.c (do_one_test): Likewise.
diff --git a/benchtests/bench-memmove-large.c b/benchtests/bench-memmove-large.c
index 5230c6e..dc02ec2 100644
--- a/benchtests/bench-memmove-large.c
+++ b/benchtests/bench-memmove-large.c
@@ -23,14 +23,15 @@
 #define TEST_NAME "memmove"
 #define TIMEOUT (20 * 60)
 #include "bench-string.h"
+#include "json-lib.h"
 
 IMPL (memmove, 1)
 
 typedef char *(*proto_t) (char *, const char *, size_t);
 
 static void
-do_one_test (impl_t *impl, char *dst, char *src, const char *orig_src,
-	     size_t len)
+do_one_test (json_ctx_t *json_ctx, impl_t *impl, char *dst, char *src, const
+	     char *orig_src, size_t len)
 {
   size_t i, iters = 16;
   timing_t start, stop, cur;
@@ -44,11 +45,11 @@ do_one_test (impl_t *impl, char *dst, char *src, const char *orig_src,
 
   TIMING_DIFF (cur, start, stop);
 
-  TIMING_PRINT_MEAN ((double) cur, (double) iters);
+  json_element_double (json_ctx, (double) cur / (double) iters);
 }
 
 static void
-do_test (size_t align1, size_t align2, size_t len)
+do_test (json_ctx_t *json_ctx, size_t align1, size_t align2, size_t len)
 {
   size_t i, j;
   char *s1, *s2;
@@ -67,35 +68,57 @@ do_test (size_t align1, size_t align2, size_t len)
   for (i = 0, j = 1; i < len; i++, j += 23)
     s1[i] = j;
 
-  printf ("Length %4zd, alignment %2zd/%2zd:", len, align1, align2);
+  json_element_object_begin (json_ctx);
+  json_attr_uint (json_ctx, "length", (double) len);
+  json_attr_uint (json_ctx, "align1", (double) align1);
+  json_attr_uint (json_ctx, "align2", (double) align2);
+  json_array_begin (json_ctx, "timings");
 
   FOR_EACH_IMPL (impl, 0)
-    do_one_test (impl, s2, (char *) (buf2 + align1), s1, len);
+    do_one_test (json_ctx, impl, s2, (char *) (buf2 + align1), s1, len);
 
-  putchar ('\n');
+  json_array_end (json_ctx);
+  json_element_object_end (json_ctx);
 }
 
 int
 test_main (void)
 {
+  json_ctx_t json_ctx;
   size_t i;
 
   test_init ();
 
-  printf ("%23s", "");
+  json_init (&json_ctx, 0, stdout);
+
+  json_document_begin (&json_ctx);
+  json_attr_string (&json_ctx, "timing_type", TIMING_TYPE);
+
+  json_attr_object_begin (&json_ctx, "functions");
+  json_attr_object_begin (&json_ctx, "memmove");
+  json_attr_string (&json_ctx, "bench-variant", "large");
+
+  json_array_begin (&json_ctx, "ifuncs");
+
   FOR_EACH_IMPL (impl, 0)
-    printf ("\t%s", impl->name);
-  putchar ('\n');
+    json_element_string (&json_ctx, impl->name);
+  json_array_end (&json_ctx);
 
+  json_array_begin (&json_ctx, "results");
   for (i = START_SIZE; i <= MIN_PAGE_SIZE; i <<= 1)
     {
-      do_test (0, 64, i + 7);
-      do_test (0, 3, i + 15);
-      do_test (3, 0, i + 31);
-      do_test (3, 7, i + 63);
-      do_test (9, 5, i + 127);
+      do_test (&json_ctx, 0, 64, i + 7);
+      do_test (&json_ctx, 0, 3, i + 15);
+      do_test (&json_ctx, 3, 0, i + 31);
+      do_test (&json_ctx, 3, 7, i + 63);
+      do_test (&json_ctx, 9, 5, i + 127);
     }
 
+  json_array_end (&json_ctx);
+  json_attr_object_end (&json_ctx);
+  json_attr_object_end (&json_ctx);
+  json_document_end (&json_ctx);
+
   return ret;
 }
 
diff --git a/benchtests/bench-memmove.c b/benchtests/bench-memmove.c
index 93c58a6..92a655f 100644
--- a/benchtests/bench-memmove.c
+++ b/benchtests/bench-memmove.c
@@ -23,6 +23,7 @@
 # define TEST_NAME "memmove"
 #endif
 #include "bench-string.h"
+#include "json-lib.h"
 
 char *simple_memmove (char *, const char *, size_t);
 
@@ -64,8 +65,8 @@ simple_memmove (char *dst, const char *src, size_t n)
 }
 
 static void
-do_one_test (impl_t *impl, char *dst, char *src, const char *orig_src,
-	     size_t len)
+do_one_test (json_ctx_t *json_ctx, impl_t *impl, char *dst, char *src, const
+	     char *orig_src, size_t len)
 {
   size_t i, iters = INNER_LOOP_ITERS;
   timing_t start, stop, cur;
@@ -83,11 +84,11 @@ do_one_test (impl_t *impl, char *dst, char *src, const char *orig_src,
 
   TIMING_DIFF (cur, start, stop);
 
-  TIMING_PRINT_MEAN ((double) cur, (double) iters);
+  json_element_double (json_ctx, (double) cur / (double) iters);
 }
 
 static void
-do_test (size_t align1, size_t align2, size_t len)
+do_test (json_ctx_t *json_ctx, size_t align1, size_t align2, size_t len)
 {
   size_t i, j;
   char *s1, *s2;
@@ -106,60 +107,82 @@ do_test (size_t align1, size_t align2, size_t len)
   for (i = 0, j = 1; i < len; i++, j += 23)
     s1[i] = j;
 
-  printf ("Length %4zd, alignment %2zd/%2zd:", len, align1, align2);
+  json_element_object_begin (json_ctx);
+  json_attr_uint (json_ctx, "length", (double) len);
+  json_attr_uint (json_ctx, "align1", (double) align1);
+  json_attr_uint (json_ctx, "align2", (double) align2);
+  json_array_begin (json_ctx, "timings");
 
   FOR_EACH_IMPL (impl, 0)
-    do_one_test (impl, s2, (char *) (buf2 + align1), s1, len);
+    do_one_test (json_ctx, impl, s2, (char *) (buf2 + align1), s1, len);
 
-  putchar ('\n');
+  json_array_end (json_ctx);
+  json_element_object_end (json_ctx);
 }
 
 static int
 test_main (void)
 {
+  json_ctx_t json_ctx;
   size_t i;
 
   test_init ();
 
-  printf ("%23s", "");
+  json_init (&json_ctx, 0, stdout);
+
+  json_document_begin (&json_ctx);
+  json_attr_string (&json_ctx, "timing_type", TIMING_TYPE);
+
+  json_attr_object_begin (&json_ctx, "functions");
+  json_attr_object_begin (&json_ctx, "memmove");
+  json_attr_string (&json_ctx, "bench-variant", "default");
+
+  json_array_begin (&json_ctx, "ifuncs");
+
   FOR_EACH_IMPL (impl, 0)
-    printf ("\t%s", impl->name);
-  putchar ('\n');
+    json_element_string (&json_ctx, impl->name);
+  json_array_end (&json_ctx);
 
+  json_array_begin (&json_ctx, "results");
   for (i = 0; i < 14; ++i)
     {
-      do_test (0, 32, 1 << i);
-      do_test (32, 0, 1 << i);
-      do_test (0, i, 1 << i);
-      do_test (i, 0, 1 << i);
+      do_test (&json_ctx, 0, 32, 1 << i);
+      do_test (&json_ctx, 32, 0, 1 << i);
+      do_test (&json_ctx, 0, i, 1 << i);
+      do_test (&json_ctx, i, 0, 1 << i);
     }
 
   for (i = 0; i < 32; ++i)
     {
-      do_test (0, 32, i);
-      do_test (32, 0, i);
-      do_test (0, i, i);
-      do_test (i, 0, i);
+      do_test (&json_ctx, 0, 32, i);
+      do_test (&json_ctx, 32, 0, i);
+      do_test (&json_ctx, 0, i, i);
+      do_test (&json_ctx, i, 0, i);
     }
 
   for (i = 3; i < 32; ++i)
     {
       if ((i & (i - 1)) == 0)
 	continue;
-      do_test (0, 32, 16 * i);
-      do_test (32, 0, 16 * i);
-      do_test (0, i, 16 * i);
-      do_test (i, 0, 16 * i);
+      do_test (&json_ctx, 0, 32, 16 * i);
+      do_test (&json_ctx, 32, 0, 16 * i);
+      do_test (&json_ctx, 0, i, 16 * i);
+      do_test (&json_ctx, i, 0, 16 * i);
     }
 
   for (i = 32; i < 64; ++i)
     {
-      do_test (0, 0, 32 * i);
-      do_test (i, 0, 32 * i);
-      do_test (0, i, 32 * i);
-      do_test (i, i, 32 * i);
+      do_test (&json_ctx, 0, 0, 32 * i);
+      do_test (&json_ctx, i, 0, 32 * i);
+      do_test (&json_ctx, 0, i, 32 * i);
+      do_test (&json_ctx, i, i, 32 * i);
     }
 
+  json_array_end (&json_ctx);
+  json_attr_object_end (&json_ctx);
+  json_attr_object_end (&json_ctx);
+  json_document_end (&json_ctx);
+
   return ret;
 }
 