diff --git a/ChangeLog b/ChangeLog
index d7d81ac..c5a5c9c 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,22 @@
+2017-11-16  Siddhesh Poyarekar  <siddhesh@sourceware.org>
+
+	* INSTALL: Update sourceware link to https.
+	* NEWS: Likewise.
+	* configure: Likewise.
+	* configure.ac: Likewise.
+	* crypt/md5test-giant.c: Likewise.
+	* dlfcn/bug-atexit1.c: Likewise.
+	* dlfcn/bug-atexit2.c: Likewise.
+	* localedata/README: Likewise.
+	* malloc/tst-mallocfork.c: Likewise.
+	* manual/install.texi: Likewise.
+	* nptl/tst-pthread-getattr.c: Likewise.
+	* stdio-common/tst-fgets.c: Likewise.
+	* stdio-common/tst-fwrite.c: Likewise.
+	* sunrpc/Makefile: Likewise.
+	* sysdeps/arm/armv7/multiarch/memcpy_impl.S: Likewise.
+	* wcsmbs/tst-mbrtowc2.c: Likewise.
+
 2017-11-15  Martin Sebor  <msebor@redhat.com>
 
 	* misc/sys/cdefs.h (__attribute_nonstring__): New macro.
diff --git a/INSTALL b/INSTALL
index bc972b2..35e82fb 100644
--- a/INSTALL
+++ b/INSTALL
@@ -2,7 +2,7 @@ Installing the GNU C Library
 ****************************
 
 Before you do anything else, you should read the FAQ at
-<http://sourceware.org/glibc/wiki/FAQ>.  It answers common questions and
+<https://sourceware.org/glibc/wiki/FAQ>.  It answers common questions and
 describes problems you may experience with compilation and installation.
 
    You will need recent versions of several GNU tools: definitely GCC
@@ -541,7 +541,7 @@ remain unfixed for all eternity, if not longer.
    It is a good idea to verify that the problem has not already been
 reported.  Bugs are documented in two places: The file 'BUGS' describes
 a number of well known bugs and the central GNU C Library bug tracking
-system has a WWW interface at <http://sourceware.org/bugzilla/>.  The
+system has a WWW interface at <https://sourceware.org/bugzilla/>.  The
 WWW interface gives you access to open and closed reports.  A closed
 report normally includes a patch or a hint on solving the problem.
 
diff --git a/NEWS b/NEWS
index 520db40..1c5da21 100644
--- a/NEWS
+++ b/NEWS
@@ -2,7 +2,7 @@ GNU C Library NEWS -- history of user-visible changes.
 Copyright (C) 1992-2017 Free Software Foundation, Inc.
 See the end for copying conditions.
 
-Please send GNU C library bug reports via <http://sourceware.org/bugzilla/>
+Please send GNU C library bug reports via <https://sourceware.org/bugzilla/>
 using `glibc' in the "product" field.
 
 Version 2.27
diff --git a/configure b/configure
index c8697d9..d9d9243 100755
--- a/configure
+++ b/configure
@@ -2,7 +2,7 @@
 # Guess values for system-dependent variables and create Makefiles.
 # Generated by GNU Autoconf 2.69 for GNU C Library (see version.h).
 #
-# Report bugs to <http://sourceware.org/bugzilla/>.
+# Report bugs to <https://sourceware.org/bugzilla/>.
 #
 #
 # Copyright (C) 1992-1996, 1998-2012 Free Software Foundation, Inc.
@@ -266,7 +266,7 @@ fi
     $as_echo "$0: be upgraded to zsh 4.3.4 or later."
   else
     $as_echo "$0: Please tell bug-autoconf@gnu.org and
-$0: http://sourceware.org/bugzilla/ about your system,
+$0: https://sourceware.org/bugzilla/ about your system,
 $0: including any error possibly output before this
 $0: message. Then install a modern shell, or manually run
 $0: the script under such a shell if you do have one."
@@ -581,7 +581,7 @@ PACKAGE_NAME='GNU C Library'
 PACKAGE_TARNAME='glibc'
 PACKAGE_VERSION='(see version.h)'
 PACKAGE_STRING='GNU C Library (see version.h)'
-PACKAGE_BUGREPORT='http://sourceware.org/bugzilla/'
+PACKAGE_BUGREPORT='https://sourceware.org/bugzilla/'
 PACKAGE_URL='http://www.gnu.org/software/glibc/'
 
 ac_unique_file="include/features.h"
@@ -1494,7 +1494,7 @@ Some influential environment variables:
 Use these variables to override the choices made by `configure' or to help
 it to find libraries and programs with nonstandard names/locations.
 
-Report bugs to <http://sourceware.org/bugzilla/>.
+Report bugs to <https://sourceware.org/bugzilla/>.
 GNU C Library home page: <http://www.gnu.org/software/glibc/>.
 General help using GNU software: <http://www.gnu.org/gethelp/>.
 _ACEOF
@@ -2188,12 +2188,12 @@ _ACEOF
 
 # We require GCC, and by default use its preprocessor.  Override AC_PROG_CPP
 # here to work around the Autoconf issue discussed in
-# <http://sourceware.org/ml/libc-alpha/2013-01/msg00721.html>.
+# <https://sourceware.org/ml/libc-alpha/2013-01/msg00721.html>.
 # AC_PROG_CPP
 
 # We require GCC.  Override _AC_PROG_CC_C89 here to work around the Autoconf
 # issue discussed in
-# <http://sourceware.org/ml/libc-alpha/2013-01/msg00757.html>.
+# <https://sourceware.org/ml/libc-alpha/2013-01/msg00757.html>.
 
 
 
@@ -7286,7 +7286,7 @@ $config_headers
 Configuration commands:
 $config_commands
 
-Report bugs to <http://sourceware.org/bugzilla/>.
+Report bugs to <https://sourceware.org/bugzilla/>.
 GNU C Library home page: <http://www.gnu.org/software/glibc/>.
 General help using GNU software: <http://www.gnu.org/gethelp/>."
 
diff --git a/configure.ac b/configure.ac
index 9f25c9f..8ebc490 100644
--- a/configure.ac
+++ b/configure.ac
@@ -1,6 +1,6 @@
 dnl Process this file with autoconf to produce a configure script.
 dnl Note we do not use AC_PREREQ here!  See aclocal.m4 for what we use instead.
-AC_INIT([GNU C Library], [(see version.h)], [http://sourceware.org/bugzilla/], [glibc])
+AC_INIT([GNU C Library], [(see version.h)], [https://sourceware.org/bugzilla/], [glibc])
 AC_CONFIG_SRCDIR([include/features.h])
 AC_CONFIG_HEADERS([config.h])
 AC_CONFIG_AUX_DIR([scripts])
@@ -19,7 +19,7 @@ AC_DEFUN([_AC_INCLUDES_DEFAULT_REQUIREMENTS],
 
 # We require GCC, and by default use its preprocessor.  Override AC_PROG_CPP
 # here to work around the Autoconf issue discussed in
-# <http://sourceware.org/ml/libc-alpha/2013-01/msg00721.html>.
+# <https://sourceware.org/ml/libc-alpha/2013-01/msg00721.html>.
 AC_DEFUN([AC_PROG_CPP],
 [AC_REQUIRE([AC_PROG_CC])dnl
 AC_ARG_VAR([CPP],      [C preprocessor])dnl
@@ -36,7 +36,7 @@ AC_SUBST(CPP)dnl
 
 # We require GCC.  Override _AC_PROG_CC_C89 here to work around the Autoconf
 # issue discussed in
-# <http://sourceware.org/ml/libc-alpha/2013-01/msg00757.html>.
+# <https://sourceware.org/ml/libc-alpha/2013-01/msg00757.html>.
 AC_DEFUN([_AC_PROG_CC_C89], [[$1]])
 
 dnl This is here so we can set $subdirs directly based on configure fragments.
diff --git a/crypt/md5test-giant.c b/crypt/md5test-giant.c
index 4655a74..a7634ee 100644
--- a/crypt/md5test-giant.c
+++ b/crypt/md5test-giant.c
@@ -1,4 +1,4 @@
-/* Testcase for http://sourceware.org/bugzilla/show_bug.cgi?id=14090.
+/* Testcase for https://sourceware.org/bugzilla/show_bug.cgi?id=14090.
    Copyright (C) 2012-2017 Free Software Foundation, Inc.
    This file is part of the GNU C Library.
 
diff --git a/dlfcn/bug-atexit1.c b/dlfcn/bug-atexit1.c
index e2d1d2f..fdfb6bc 100644
--- a/dlfcn/bug-atexit1.c
+++ b/dlfcn/bug-atexit1.c
@@ -1,5 +1,5 @@
 /* Derived from a test case in
-   http://sourceware.org/bugzilla/show_bug.cgi?id=1158.  */
+   https://sourceware.org/bugzilla/show_bug.cgi?id=1158.  */
 #include <dlfcn.h>
 #include <stdio.h>
 #include <stdlib.h>
diff --git a/dlfcn/bug-atexit2.c b/dlfcn/bug-atexit2.c
index 15e9f7a..279804d 100644
--- a/dlfcn/bug-atexit2.c
+++ b/dlfcn/bug-atexit2.c
@@ -1,5 +1,5 @@
 /* Derived from a test case in
-   http://sourceware.org/bugzilla/show_bug.cgi?id=1158.  */
+   https://sourceware.org/bugzilla/show_bug.cgi?id=1158.  */
 #include <dlfcn.h>
 #include <stdlib.h>
 #include <stdio.h>
diff --git a/localedata/README b/localedata/README
index 3e82898..e844719 100644
--- a/localedata/README
+++ b/localedata/README
@@ -42,7 +42,7 @@ especially in the section describing the `setlocale' function.
 
 All problems should be reported using
 
-  http://sourceware.org/bugzilla/
+  https://sourceware.org/bugzilla/
 
 
 One more note: the `POSIX' locale definition is not meant to be used
diff --git a/malloc/tst-mallocfork.c b/malloc/tst-mallocfork.c
index f90ce94..4ff6ec0 100644
--- a/malloc/tst-mallocfork.c
+++ b/malloc/tst-mallocfork.c
@@ -1,5 +1,5 @@
 /* Derived from the test case in
-   http://sourceware.org/bugzilla/show_bug.cgi?id=838.  */
+   https://sourceware.org/bugzilla/show_bug.cgi?id=838.  */
 #include <assert.h>
 #include <errno.h>
 #include <stdio.h>
diff --git a/manual/install.texi b/manual/install.texi
index 96b988e..f1fa28c 100644
--- a/manual/install.texi
+++ b/manual/install.texi
@@ -9,7 +9,7 @@
 @appendix Installing @theglibc{}
 
 Before you do anything else, you should read the FAQ at
-@url{http://sourceware.org/glibc/wiki/FAQ}.  It answers common
+@url{https://sourceware.org/glibc/wiki/FAQ}.  It answers common
 questions and describes problems you may experience with compilation
 and installation.
 
@@ -613,7 +613,7 @@ reported.  Bugs are documented in two places: The file @file{BUGS}
 describes a number of well known bugs and the central @glibcadj{}
 bug tracking system has a
 WWW interface at
-@url{http://sourceware.org/bugzilla/}.  The WWW
+@url{https://sourceware.org/bugzilla/}.  The WWW
 interface gives you access to open and closed reports.  A closed report
 normally includes a patch or a hint on solving the problem.
 
diff --git a/nptl/tst-pthread-getattr.c b/nptl/tst-pthread-getattr.c
index 86719f9..27c60c8 100644
--- a/nptl/tst-pthread-getattr.c
+++ b/nptl/tst-pthread-getattr.c
@@ -35,8 +35,8 @@
    results in a test case failure.  To avoid these problems, we cap the stack
    size to one less than 8M.  See the following mailing list threads for more
    information about this problem:
-   <http://sourceware.org/ml/libc-alpha/2012-06/msg00599.html>
-   <http://sourceware.org/ml/libc-alpha/2012-06/msg00713.html>.  */
+   <https://sourceware.org/ml/libc-alpha/2012-06/msg00599.html>
+   <https://sourceware.org/ml/libc-alpha/2012-06/msg00713.html>.  */
 #define MAX_STACK_SIZE (8192 * 1024 - 1)
 
 static size_t pagesize;
diff --git a/stdio-common/tst-fgets.c b/stdio-common/tst-fgets.c
index 0aa9030..912b706 100644
--- a/stdio-common/tst-fgets.c
+++ b/stdio-common/tst-fgets.c
@@ -1,5 +1,5 @@
 /* Derived from the test case in
-   http://sourceware.org/bugzilla/show_bug.cgi?id=713.  */
+   https://sourceware.org/bugzilla/show_bug.cgi?id=713.  */
 #include <stdio.h>
 
 static int
diff --git a/stdio-common/tst-fwrite.c b/stdio-common/tst-fwrite.c
index 2986c89..1db10d0 100644
--- a/stdio-common/tst-fwrite.c
+++ b/stdio-common/tst-fwrite.c
@@ -1,5 +1,5 @@
 /* Derived from the test case in
-   http://sourceware.org/bugzilla/show_bug.cgi?id=1078.  */
+   https://sourceware.org/bugzilla/show_bug.cgi?id=1078.  */
 #include <stdio.h>
 #include <stdlib.h>
 #include <unistd.h>
diff --git a/sunrpc/Makefile b/sunrpc/Makefile
index 125d538..f1b8323 100644
--- a/sunrpc/Makefile
+++ b/sunrpc/Makefile
@@ -173,7 +173,7 @@ cross-rpcgen-objs := $(addprefix $(objpfx)cross-,$(rpcgen-objs))
 
 # When generic makefile support for build system programs is
 # available, it should replace this code.  See
-# <http://sourceware.org/bugzilla/show_bug.cgi?id=14087>.
+# <https://sourceware.org/bugzilla/show_bug.cgi?id=14087>.
 $(cross-rpcgen-objs): $(objpfx)cross-%.o: %.c $(before-compile)
 	$(BUILD_CC) $($(basename $(<F))-CFLAGS) $(ALL_BUILD_CFLAGS) $< \
 		$(OUTPUT_OPTION) $(native-compile-mkdep-flags) -c
diff --git a/sysdeps/arm/armv7/multiarch/memcpy_impl.S b/sysdeps/arm/armv7/multiarch/memcpy_impl.S
index c1b9fb0..3c7a717 100644
--- a/sysdeps/arm/armv7/multiarch/memcpy_impl.S
+++ b/sysdeps/arm/armv7/multiarch/memcpy_impl.S
@@ -276,7 +276,7 @@ ENTRY(memcpy)
 #ifdef USE_NEON
 	/* These need an extra layer of macro just to work around a
 	   bug in the assembler's parser when an operand starts with
-	   a {...}.  http://sourceware.org/bugzilla/show_bug.cgi?id=15647
+	   a {...}.  https://sourceware.org/bugzilla/show_bug.cgi?id=15647
 	   tracks that bug; it was not fixed as of binutils-2.23.2.  */
 	.macro neon_load_d0 reg
 	vld1.8	{d0}, [\reg]!
diff --git a/wcsmbs/tst-mbrtowc2.c b/wcsmbs/tst-mbrtowc2.c
index 975043a..95e9541 100644
--- a/wcsmbs/tst-mbrtowc2.c
+++ b/wcsmbs/tst-mbrtowc2.c
@@ -1,4 +1,5 @@
-/* Derived from the test case in http://sourceware.org/bugzilla/show_bug.cgi?id=714 */
+/* Derived from the test case in
+   https://sourceware.org/bugzilla/show_bug.cgi?id=714  */
 #include <locale.h>
 #include <stdio.h>
 #include <string.h>